/*
* Atrix Team 1994, 2001 - http://www.atrix.cjb.net
* Original Code by SeCToR-X 
* Modified by SeCToR-X 13/01/2001
*
* File modified for Pyros 1.5
*/

#define SA struct sockaddr
#define SIN_LEN sizeof(struct sockaddr_in)
#define IPV4_ADDRLEN 16

void showhelp(char *, char *);

int ConnectCheck(struct sockaddr_in, int, int);

const char *ipv4_ntop(int, const void *, char *, size_t);
const char *ipv4_showname(int, const void *, char *, size_t);

FILE *stream;

int pwingate(char *targetip, int wclass, int ttimer)
{
 int i, j = 0, status, children = 128, timeout = 7, resolve = 0, class = 0;
 char destip[15], *networkID, c;
 struct sockaddr_in sin;
 
 networkID = targetip; /*define target*/
 class = wclass; /*define class*/
 timeout = ttimer;

 if(class == 1)
  fprintf(stderr, "Scanning %s.*.*:23 children:%i, timeout:%i\n\n", networkID, children, timeout);
 if(class == 2)
  fprintf(stderr, "Scanning %s.*:23 children:%i, timeout:%i\n\n", networkID, children, timeout);
 sin.sin_family = AF_INET;
 sin.sin_port = htons(23);
  if (class==1){
   for(j = 0; j < 256; j++) {
   for(i = 0; i < children; i++) {
      sprintf(destip, "%s.%d.%d", networkID,j, i);
      inet_aton(destip, &sin.sin_addr);
      if(!fork()) ConnectCheck(sin, timeout, resolve);
   }
   for(i = children + 1; i < 256; i++) {
      wait(&status); 
      sprintf(destip, "%s.%d.%d", networkID,j, i);
      inet_aton(destip, &sin.sin_addr);
      if(!fork()) ConnectCheck(sin, timeout, resolve);
   }
 }
 }
  if(class == 2) {
   for(i = 0; i < children; i++) {
    sprintf(destip, "%s.%d", networkID, i);
    inet_aton(destip, &sin.sin_addr);
    if(!fork()) ConnectCheck(sin, timeout, resolve);
   }
   for(i = children + 1; i < 256; i++) {
    wait(&status);
    sprintf(destip, "%s.%d", networkID, i);
    inet_aton(destip, &sin.sin_addr);
    if(!fork()) ConnectCheck(sin, timeout, resolve);
  }
  for(;;) {
   if((waitpid(-1, &status, WNOHANG) == -1) && (errno == ECHILD))
    exit(EXIT_SUCCESS);
  }
 }
}

int ConnectCheck(struct sockaddr_in DestAddr, int timeout, int resolve)
{
 int result, ret, socketfd;
 char hostname[60], buffer1[64];

 if((socketfd = socket(AF_INET, SOCK_STREAM, 0)) < 0) exit (EXIT_FAILURE);
 alarm(timeout);
 result = connect(socketfd, (SA *)&DestAddr, SIN_LEN);
 if(!result) {
  alarm(timeout);
  memset(buffer1, '\0', 64);
  if((ret = read(socketfd, buffer1, 64)) > 0) {
   ret = read(socketfd, buffer1, 64);
   if(!(memcmp(buffer1, "WinGate>", 8)) ||
      !(memcmp(buffer1, "Too man", 7))) {
  
   stream = fopen("wingate.log", "a");
    printf("Wingate found: %s\n\a", ipv4_ntop(AF_INET, &DestAddr.sin_addr.s_addr, hostname, 59));
    fprintf(stream, "%s\n", ipv4_ntop(AF_INET, &DestAddr.sin_addr.s_addr, hostname, 59));
    fclose(stream);
   }
  }
  close(socketfd);
 }
  exit(EXIT_SUCCESS);
}

const char *

ipv4_ntop(int family, const void *addrptr, char *strptr, size_t len)
{
 const u_char *p = (const u_char *)addrptr;

 if(family == AF_INET) {
  char temp[IPV4_ADDRLEN];
  snprintf(temp, sizeof(temp), "%d.%d.%d.%d", p[0], p[1], p[2], p[3]);
  if(strlen(temp) >= len) {
   errno = ENOSPC;
   return(NULL);
  }
  strcpy(strptr, temp);
  return(strptr);
 }
 errno = EAFNOSUPPORT;
 return(NULL);
}
 
const char *

ipv4_showname(int family, const void *addrptr, char *strptr, size_t len)
{
 struct hostent *he;
 size_t aflen;
 
 if(family == AF_INET) aflen = 4;
 else {
  errno = EAFNOSUPPORT;
  return(NULL);
 }
 
 if((he = gethostbyaddr(addrptr, aflen, family)) != NULL) {
  if(strlen(he->h_name) < len) {
  strcpy(strptr, he->h_name);
  return(strptr);
   }
  }
 return(ipv4_ntop(family, addrptr, strptr, len));
}

/* end of program */ 
