/*
* Atrix Team 1994, 2001 - http://www.atrix.cjb.net
* Original Code by SeCToR-X 
* Modified by SeCToR-X 03/01/2001
*
* File modified for Pyros 1.5
*/

#define MAXPACKET 4096
#define DEFAULT_TIMEOUT 10
#define DEFAULT_RESEND 6
#define SPORT 1
#define EPORT 1024

extern char *optarg;
extern int optind;


void start_scanning(unsigned short sport,unsigned short eport,struct in_addr myaddr,unsigned short timeout,int maxretry)
{
  struct sockaddr_in myudp;
  char buff[] = "This was a blatant UDP port scan.";
  int udpsock, rawsock, retry, retval,iplen;
  unsigned short port;
  fd_set r;
  struct timeval mytimeout;
  struct icmp *packet;
  struct ip *iphdr;
  struct servent *service;
  unsigned char recvbuff[MAXPACKET];

  if((udpsock = socket(AF_INET,SOCK_DGRAM,IPPROTO_UDP)) < 0)
    {
      perror("socket()");
      exit(-1);
    }

  if((rawsock = socket(AF_INET,SOCK_RAW,IPPROTO_ICMP)) < 0)
    {
      perror("socket()");
      exit(-1);
    }

  if(!(sport))
    sport = SPORT;
  if(!(eport))
    eport = EPORT;
  if(!(timeout))
    timeout = DEFAULT_TIMEOUT;
  if(!(maxretry))
    maxretry = DEFAULT_RESEND;

  if(sport > eport)
    {
      fprintf(stderr,"Uh you've got the start-port at %u and the end-port at %u this doesnt look right.\n",sport,eport);
      exit(-1);
    }

  bcopy(&myaddr.s_addr,&myudp.sin_addr.s_addr,sizeof(myaddr.s_addr));

  myudp.sin_family = AF_INET;

  mytimeout.tv_sec = timeout;
  mytimeout.tv_usec = 0;

  for(port = sport;port < eport;port++)
    {
      
      myudp.sin_port = htons(port);
      
      retry = 0;
    
      while(retry++ < maxretry)
	{
	  
	  /* I'll use select to do the timeout. Its a bit more
	     'portable'. Than using a signal */
	  
	  if((sendto(udpsock,buff,sizeof(buff),0x0,(struct sockaddr *)&myudp,sizeof(myudp))) < 0)
	    {
	    }
	

	  FD_ZERO(&r);
	  FD_SET(rawsock,&r);
	  
	  retval = select((rawsock+1),&r,NULL,NULL,&mytimeout);
	  
	  if(retval)
	    {
	      /* We got an answer lets check if its the one we want. */
      
	      if((recvfrom(rawsock,&recvbuff,sizeof(recvbuff),0x0,NULL,NULL)) < 0)
		{
		  perror("Recv");
		  exit(-1);
		}

	      /* Problem with getting back the address of the host
		 is that not all hosts will answer icmp unreachable
		 directly from thier own host. */

		  iphdr = (struct ip *)recvbuff;
		  iplen = iphdr->ip_hl << 2;
		  
		  packet = (struct icmp *)(recvbuff + iplen);

		  if((packet->icmp_type == ICMP_UNREACH) && (packet->icmp_code == ICMP_UNREACH_PORT))
		    break;
	    
	    }
	  else
	    continue;
	}

      if(retry >= maxretry)
	{
	  if((service = getservbyport(htons(port),"udp")) == NULL)
	      fprintf(stdout,"Unknown port %u, open.\n",port);
	  else
	    fprintf(stdout,"UDP service %s open.\n",service->s_name);
	  fflush(stdout);
	}
    }
}
	  
struct in_addr resolv(char *address)
{
  struct in_addr myaddr;
  struct hostent *host;

  if((myaddr.s_addr = inet_addr(address)) == INADDR_NONE)
    {
      if((host = gethostbyname(address)) == NULL)
	fprintf(stderr,"%s Invalid address\n",address);
      else
	{
	  bcopy((int *) * &host->h_addr,&myaddr.s_addr,host->h_length); 
	  return myaddr;
	}
    }

    return myaddr;
}



int pxudpscan(char *targetip, int spo, int edp, int twm)
{
  unsigned short sport = 0;
  unsigned short eport = 0;
  unsigned short timeout = 0;
  unsigned short maxretry = 0;
  struct in_addr myaddr;
  char c;
  
  sport   = spo;
  eport   = edp;
  timeout = twm;
  myaddr  = resolv(targetip);

  start_scanning(sport,eport,myaddr,timeout,maxretry);

  exit(0);
}
